\ START:PREPARE
"FORTH RULEZZ" 2CONSTANT SECRET \ Comes from elsewhere

10 CONSTANT X-MARG
10 CONSTANT WORD-LINE
15 CONSTANT LETTER-LINE
SECRET CONSTANT LENGTH DROP
LENGTH CONSTANT ROUNDS 
LENGTH BUFFER: HIDDEN
LENGTH BUFFER: VISIBLE

SECRET HIDDEN SWAP MOVE 
\ END:PREPARE

\ START:ONCE
: GET-LETTER ( -- u flag ) KEY TOUPPER DUP [CHAR] A [CHAR] Z 1+ WITHIN ;

: UPDATE-VISIBLE ( u -- )
  LENGTH 0 DO
    DUP HIDDEN I + C@ DUP ROT =
    IF
      VISIBLE I + C!
    ELSE
      DROP 
    THEN
  LOOP
  DROP
;

: PLAY-ONCE ( -- ) GET-LETTER SWAP DUP ROT 0<> IF UPDATE-VISIBLE THEN ;
\ END:ONCE

\ START:MANY
: PLAY-ROUNDS ( -- flag )
  FALSE \ Assume failure
  ROUNDS 0 DO
    PLAY-ONCE
    X-MARG WORD-LINE AT-XY VISIBLE LENGTH TYPE
    X-MARG I + LETTER-LINE AT-XY EMIT
    VISIBLE LENGTH "*" SEARCH ROT DROP SWAP DROP 0= IF
      DROP TRUE \ Change our mind
      LEAVE
    THEN
  LOOP
; 
\ END:MANY

\ START:ALL
: PLAY ( -- )
  VISIBLE LENGTH '*' FILL
  PAD ROUNDS '_' FILL
  
  BL UPDATE-VISIBLE \ "Blanks" are not to be guessed
  PAGE
  X-MARG WORD-LINE AT-XY VISIBLE LENGTH TYPE
  X-MARG LETTER-LINE AT-XY PAD ROUNDS TYPE
  X-MARG LETTER-LINE AT-XY
  
  PLAY-ROUNDS
  
  FORM DROP 0 SWAP 4 - AT-XY
  IF "Success!" ELSE "You failed..." THEN TYPE CR
  "Press any key to exit" TYPE CR
  KEY DROP
;
\ END:ALL
